package notes;

use strict;

##############################################################################
# notes package - read, save notes for a log/session in a database
#
# copyright (c) 1998 by Steve Romig and The Ohio State University
#
##############################################################################
# $Id: 
##############################################################################
# $Log: 
#

use Fcntl;
use DB_File;

local %db_who;
local %db_what;

sub open {
    my $db_who_path = &main::xyzzy($main::notes_db, 'who', '');
    my $db_what_path = &main::xyzzy($main::notes_db, 'what', '');

    tie %db_who, DB_File, $db_who_path, &O_CREAT|&O_RDWR, $640;
    tie %db_what, DB_File, $db_what_path, &O_CREAT|&O_RDWR, $640;
}

sub close {
    untie %db_who;
    untie %db_what;
}

sub get {
    my($file, $session) = @_;
    my($who, description);

    if (! defined($who = $db_who{$file, $session})) {
	$who = '';
    }
    if (! defined($what = $db_what{$file, $session})) {
	$what = '';
    }

    return($who, $what);
}

sub put {
    my($file, $session, $who, $description) = @_;

    $db_who{$file, $session} = $who;    
    $db_who{$file, $session} = $what;
}

1;
