package notes_window;

use strict;

##############################################################################
# notes_window package - create a window containing the notes relating 
# to a log file or session.
#
# copyright (c) 1997 by Steve Romig and The Ohio State University
#
##############################################################################
# $Id: 
##############################################################################
# $Log: 
#

#
#
sub create {
    my($file, $session) = @_;
    my($who, $what);

    my $window = $log_window::main->Toplevel;
  
    # create this here for references
    #
    my $who_text = $window->Text(-relief => 'sunken',
				 -background => $main::background_color,
				 -foreground => $main::foreground_color,
				 -width => $width,
				 -height => 1,
				 -setgrid => 'yes');


    my $description = $window->Text(-relief => 'sunken',
				    -background => $main::background_color,
				    -foreground => $main::foreground_color,
				    -width => $width,
				    -height => 10,
				    -setgrid => 'yes');

    # frame for the top row of buttons: exit, save
    #
    # +-------------------------
    # | Exit Save
    #
    my $button_frame = $window->Frame(-relief => 'raised', -bd => 2);
    $button_frame->pack(-side => 'top', -fill => 'x');

    my $exit_button = 
	$button_frame->Button(
			      -text => "Exit",
			      -command => ['destroy', $window]);
    $exit_button->pack(-side => 'left');

    my $save_button = 
	$button_frame->Button(
			      -text => "Save",
			      -command => sub {&notes::put($file, $session, $who, $what)});

    $save_button->pack(-side => 'left');
			      
    # +-------------------------
    # | Exit Save
    # | who XXXXXXXX
    #

    # fill the text window

    ($who, $what) = &notes::get($file, $session);
    &fill_stuff($who, $what);

    $description->pack(-side => 'left',
		       -fill => 'both',
		       -expand => 'yes');

    # scroll bar for the text widget
    my $description_scroll = 
	$window->Scrollbar(-command => ['yview', $description]);

    $description->configure(-yscrollcommand => ['set', $description_scroll]);

    $description_scroll->pack(-side => 'right', 
			      -fill => 'y');
}

sub fill_stuff {
    my($who, $what) = @_;


1;
