package window;

use strict;

##############################################################################
# window package - misc window support things
#
# copyright (c) 1997 by Steve Romig and The Ohio State University
#
##############################################################################
# $Id: window.pm,v 1.2 1998/03/12 00:55:58 romig Exp $
##############################################################################
# $Log: window.pm,v $
# Revision 1.2  1998/03/12 00:55:58  romig
# *** empty log message ***
#
#

sub define_tags {
    my($box, $create) = @_;

    # hot is raised, visited is underlined or red
    #
    if ($log_window::main->depth == 1) { # black and white
	$box->tag('configure', 'hot',
		  -relief => 'raised',
		  -borderwidth => 2);
	$box->tag('configure', 'visited',
		  -underline => 1);
    } else {
	$box->tag('configure', 'hot',
		  -relief => 'raised',
		  -background => $main::selection_color,
		  -borderwidth => 2);
	$box->tag('configure', 'visited',
		  -foreground => $main::seen_color);
    }

    $box->tag('configure', 'go');

    $box->tag('bind', 'go',
	      '<Double-Button-1>' => 
	          sub { &invoke($box, $box->index('current'), $create) });

    my $lastline = '';
    $box->tag('bind', 'go',
	      '<Enter>' => sub {
		  my $event = $box->XEvent;
		  my($x, $y) = ($event->x, $event->y);
		  $lastline = $box->index("\@$x,$y linestart");
#		  print "enter $lastline\n";
		  $box->tag('add', 'hot', $lastline, "$lastline lineend");
	      });

    $box->tag('bind', 'go',
	      '<Leave>' => sub {
#		  print "leave\n";
		  $box->tag('remove', 'hot', '1.0', 'end');
	      });

    $box->tag('bind', 'go',
	      '<Motion>' => sub {
		  my $event = $box->XEvent;
		  my($x, $y) = ($event->x, $event->y);
		  my $newline = $box->index("\@$x,$y linestart");
		  if ($newline ne $lastline) {
		      $box->tag('remove', 'hot', '1.0', 'end');
#		      print "move from $lastline to $newline\n";
		      $lastline = $newline;
		      $box->tag('add', 'hot', $lastline, "$lastline lineend");
		  }
	      });
}

sub invoke {
    my($box, $index, $create) = @_;

    my $tag;
    my @tags = $box->tag('names', $index);
#    print "tags: ", join(' ', @tags), "\n";

    foreach $tag (@tags) {
	if ($tag =~ m/go-(.*)/) {
	    my $where = $1;
#	    print "where: $where\n";
	    $box->tag('add', 'visited', "$index linestart",
		      "$index lineend");
#		      "$index lineend -1 chars");
	    &$create($where);
	} 
    }
}

1;
